﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;
using System.Windows.Input;
using Stimulsoft.Report;
using Stimulsoft.Report.Dictionary;

namespace StiTest
{
    class MainVM : INotifyPropertyChanged
    {
        public event PropertyChangedEventHandler PropertyChanged;
        private void Notify(string propertyName)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
        }

        private OpenDesignerCommand _openDesigner;

        public OpenDesignerCommand OpenDesigner
        {
            get { return _openDesigner ?? (_openDesigner = new OpenDesignerCommand(prepareData)); }
        }

        private Model<Model2> prepareData()
        {
            var model = new Model<Model2>();
            model.Author = "Author";
            model.M2 = new Model2
            {
                Content = "Contnet",
                Title = "Title",
                List = new List<Model3>()
            };

            return model;
        }

        public class OpenDesignerCommand : ICommand
        {
            private Func<Model<Model2>> _prepareData;
            public bool CanExecute(object parameter)
            {
                return true;
            }

            public event EventHandler CanExecuteChanged;
            public void RaiseCanExecuteChanged()
            {
                if (CanExecuteChanged != null)
                    CanExecuteChanged(this, new EventArgs());
            }

            public void Execute(object parameter)
            {
                var report = new StiReport();
                report.RegBusinessObject("Doc", _prepareData());
                report.DesignWithWpf(true);
            }

            public OpenDesignerCommand(Func<Model<Model2>> prepareData)
            {
                _prepareData = prepareData != null ? prepareData : () => null;
            }
        }
    }
}
